
module pulse_generator(clk,reset,SetSingle,SetMultiple,SinglePulse,MultiplePulses);

input clk,reset,SetSingle,SetMultiple;          //Generate a single pulse when SetSingle=1
output reg SinglePulse,MultiplePulses;         //Generate multiple pulses when SetSingle=1 and SetMultiple=1.

localparam s0=2'b00,
s1=2'b01,
s2=2'b10,
s3=2'b11;

reg [1:0]state;
reg [1:0]next_state;
initial state<=s0;

always@(posedge clk)
 begin
   state<=next_state;
 end

 always@(posedge clk)
 begin
  if(reset)
  next_state<=s0;
 else if(!reset)

 begin
  case(state)
     s0: begin
     if(SetSingle==1)
        next_state<=s1;
     else if(SetSingle==0)
        next_state<=s0;
     end

	  s1: begin
     if(SetSingle==1)
       next_state<=s2;
     else if(SetSingle==0)
       next_state<=s0;
    end
 
     s2: begin
     if((SetSingle==1)&&(SetMultiple==0))
        next_state<=s3;
     else if((SetSingle==1)&&(SetMultiple==1))
        next_state<=s1;
     else if(SetSingle==0)
        next_state<=s0;
     end
	  
     s3: begin
       if((SetSingle==1)&&(SetMultiple==1))
         next_state<=s1;
       else if((SetSingle==1)&&(SetMultiple==0))
         next_state<=s3;
       else if(SetSingle==0)
         next_state<=s0;
       end
   endcase
   end
   end
	
	
always@(state)
    begin
    case(state)
      s0:begin
         SinglePulse=0;
         MultiplePulses=0;
      end
      s1:begin
        SinglePulse=1;
        MultiplePulses=1;
      end
      s2:begin
       SinglePulse=0;
       MultiplePulses=1;
      end
      s3:begin
       SinglePulse=0;
       MultiplePulses=1;
      end
     default:begin
       SinglePulse=0;
       MultiplePulses=0;
     end
   endcase
end
endmodule